#ifndef __MINC_1_SIMPLE_RW_H__
#define __MINC_1_SIMPLE_RW_H__

#include "minc_1_simple.h"
#include "minc_io_simple_volume.h"
#include "minc_io_fixed_vector.h"

namespace minc
{
  
  template<class T> void load_simple_volume(minc_1_reader& rw,simple_volume<T>& vol)
  {
    vol.resize(rw.ndim(1),rw.ndim(2),rw.ndim(3));
     
    if(typeid(T)==typeid(unsigned char))
    {
      rw.setup_read_byte();
      load_standard_volume(rw,vol.c_buf());
    }
    else if(typeid(T)==typeid(int))
    {
      rw.setup_read_int();
      load_standard_volume(rw,vol.c_buf());
    }
    else if(typeid(T)==typeid(fixed_vec<3,float>))
    {
      rw.setup_read_float(); 
      load_standard_volume<float>(rw,(float*)vol.c_buf());
    }
    else
    {
      rw.setup_read_float(); 
      load_standard_volume(rw,vol.c_buf());
    }
  }
  
  template<class T> void save_simple_volume(minc_1_writer& rw,const simple_volume<T>& vol)
  {
    if(typeid(T)==typeid(unsigned char))
    {
      rw.setup_write_byte();
      save_standard_volume(rw,vol.c_buf());
    }
    else if(typeid(T)==typeid(int))
    {
      rw.setup_write_int();
      save_standard_volume(rw,vol.c_buf());
    }
    else if(typeid(T)==typeid(fixed_vec<3,float>))
    {
      rw.setup_write_float(); 
      save_standard_volume<float>(rw,(float*)vol.c_buf());
    }
    else
    {
      rw.setup_write_float(); 
      save_standard_volume(rw,vol.c_buf());
    }
    
  }
  
  bool is_same(minc_1_reader& one,minc_1_reader& two,bool verbose=true);
  
};

#endif //__MINC_1_SIMPLE_RW_H__
